﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ProcessKeys
{
    public enum ProcessKeysEnum { None, ProcessCmdKey, IsInputKey, ProcessCmdKeyTrue, OnPreviewKeyDown, OnPreviewKeyDownTrue }
 
    public partial class FormMain : Form
    {
        ToolStripMenuItem item;

        public FormMain()
        {
            InitializeComponent();
            bool firstPass = true;
            foreach (String value in Enum.GetNames(typeof(ProcessKeysEnum)))
            {
                ToolStripMenuItem item = new ToolStripMenuItem();
                item.Text = value;
                item.Click += processCommandKeyToolStripMenuItem_Click;
                item.CheckOnClick = true;
                if (firstPass) item.Checked = true;
                firstPass = false;
                processToolStripMenuItem.DropDownItems.Add(item);
            }
        }

        private void processCommandKeyToolStripMenuItem_Click(object sender, EventArgs e)
        {
            item = sender as ToolStripMenuItem;
            UserControlPanel.ProcessKeys = 
                (ProcessKeysEnum) Enum.Parse(typeof(ProcessKeysEnum), item.Text);
        }

        private void processToolStripMenuItem_DropDownOpening(object sender, EventArgs e)
        {
            foreach (ToolStripMenuItem anItem in processToolStripMenuItem.DropDownItems)
            {
                anItem.Checked = item == anItem;
            }
        }

    }
}
