﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ProcessKeys
{
    public partial class UserControlPanel : UserControl
    {
        public UserControlPanel()
        {
            InitializeComponent();
        }

        public static ProcessKeysEnum ProcessKeys
        {
            get; set;
        }

        String active = "";
        private void UserControlPanel_Enter(object sender, EventArgs e)
        {
            active = "active";
            this.Invalidate();
        }

        private void UserControlPanel_Leave(object sender, EventArgs e)
        {
            active = "";
            this.Invalidate();
        }

        private void UserControlPanel_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.DrawString(active, Font, Brushes.Black, 0, 0);
        }

        private void ChangeLocation(Keys key)
        {
            Point location = this.Location;
            //Handle arrow keys
            switch (key)
            {
                case Keys.Up:
                    --location.Y;
                    break;

                case Keys.Left:
                    --location.X;
                    break;

                case Keys.Down:
                    ++location.Y;
                    break;

                case Keys.Right:
                    ++location.X;
                    break;
            }
            this.Location = location;
        }

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            if (ProcessKeys == ProcessKeysEnum.ProcessCmdKey ||
                ProcessKeys == ProcessKeysEnum.ProcessCmdKeyTrue)
            {
                ChangeLocation(keyData);
                if (ProcessKeys == ProcessKeysEnum.ProcessCmdKeyTrue)
                {
                    return true;
                }
            }
            return base.ProcessCmdKey(ref msg, keyData);
        }

        protected override bool IsInputKey(Keys keyData)
        {
            switch (keyData)
            {
                case Keys.Up:
                case Keys.Left:
                case Keys.Down:
                case Keys.Right:
                    return ProcessKeys == ProcessKeysEnum.IsInputKey;
            }
            return base.IsInputKey(keyData);
        }

        private void UserControlPanel_KeyDown(object sender, KeyEventArgs e)
        {
            if (ProcessKeys == ProcessKeysEnum.IsInputKey)
            {
                ChangeLocation(e.KeyCode);
            }
        }

        protected override void OnPreviewKeyDown(PreviewKeyDownEventArgs e)
        {
            if (ProcessKeys == ProcessKeysEnum.OnPreviewKeyDown ||
                ProcessKeys == ProcessKeysEnum.OnPreviewKeyDownTrue)
            {
                ChangeLocation(e.KeyCode);
                if (ProcessKeys == ProcessKeysEnum.OnPreviewKeyDownTrue)
                {
                    e.IsInputKey = true;
                }
            }
            base.OnPreviewKeyDown(e);
        }

    }
}
